
{Feedback Servo Demo}

CON
        _clkmode = xtal1 + pll16x    'Standard clock mode 
        _xinfreq = 5_000_000         '* crystal frequency = 80 MHz
        #12, CP0, CP1, CP2, CP3      'servo control pins
        #8,  FP0, FP1, FP2, FP3      'servo feedback pins
        #0, Servo0, Servo1, Servo2, Servo3  'servo names
        sync = 0                     'engineering
VAR
  byte  Cog
  word  commanded, actual     'angles
  long random      
  byte  DisplayServo, currentservo 'used to display all angles
  word  rcount                'counts random positionings
  word  Cmnded[4]            
  word theservo
  byte testgain
  byte  deltaMax, deltamin
OBJ
  pst      : "parallax serial terminal"
  FBS      : "FourPly"
  
PUB main              
  pst.Start (115_200)                        'start up ser terminal
  pst.str(String("hello, world   "))         'runs in cog 1
  pst.NewLine
  waitcnt(clkfreq/10+cnt)

 ' cog := FBS.start(cp0,fp0, 0,0, 0,0, 0,0)   'specify pin numbers 
  cog := FBS.start(cp0,fp0, CP1,FP1, cp2,fp2, cp3,fp3)   'specify pin numbers   
  pst.str(string("started position cog: "))       '0,0 pin numbers says no servo
  pst.dec(cog)
  pst.newline
  waitcnt(clkfreq/2+cnt)          'allow time for it to start    
 ' dira[sync] := 1                  'scope probe

  FBS.setDeltaMin(servo0, 24)
  FBS.setDeltaMin(servo1, 29)
  FBS.setDeltaMin(servo2, 25)
  FBS.setDeltaMin(servo3, 30)

 { theservo := servo3
          
  repeat deltaMin from 35 to 22
    FBS.SetDeltaMax(theservo, 180)             'vary max offset from 1500
    FBS.SetDeltaMin(theservo, deltamin)                   'force deltamin
    Myset(theservo, 100)
    waitset(theservo)
    waitcnt(clkfreq/100+cnt)
    Myset(theservo, 150)
    waitset(theservo)
    pst.newline
    pst.dec(deltamin)
  repeat          }

  repeat theservo from 0 to 3     'constant pulse width
    FBS.width(theservo, 1475)
  repeat 200
    showangles
    pst.newline
    waitcnt(clkfreq/100+cnt)
  repeat theservo from 0 to 3    
    fbs.width(theservo, 1500)
     
  repeat theservo from 0 to 3     'full scale changes
    pst.dec(theservo)
    pst.char(" ")
    MySet(theservo, 180)
    pst.dec(WaitSet(theservo))
    pst.char(" ")
    Myset(theservo, 0)
    pst.dec(WaitSet(theservo))
    pst.char(" ")
    MySet(theservo, 359)
     pst.dec(WaitSet(theservo))
    pst.char(" ")
    myset(theservo, 0)
    pst.dec(WaitSet(theservo))
    pst.newline  

  rcount := 0                                  'all four with random movements
  random := cnt                               'seed
  repeat while rcount < 100
     repeat currentservo from 0 to 3
       if fbs.checkdone(currentservo) == 0     'issue command to whichever is done
          pst.newline
          pst.dec(currentservo)               'number
          pst.str(string("  Commanded: "))
          printThree(cmnded[currentservo])
          pst.str(string("  Actual: "))
          printThree(FBS.getpos(currentservo))
          pst.str(string("  Error: "))
          pst.dec(cmnded[currentservo] - FBS.getpos(currentservo)) 
          ?random
          commanded := || random           'drop sign bit
          commanded := (commanded // 360)    'range 0..359        
          myset(currentservo,commanded)
          cmnded[currentservo] := commanded
          pst.str(string("   "))
          pst.dec(rcount++)     
  repeat                                'stop here        
  
pub MySet(servo, degrees)
     outa[sync] := 1                 'sync
     FBS.SetPos(servo,degrees)   'set position
     outa[sync] := 0

pub WaitSet(servo)            
     repeat while FBS.CheckDone(servo) <> 0    'await completion
     waitcnt(clkfreq/100+cnt)     
     return FBS.getpos(servo)

pub showangles
    repeat displayservo from 0 to 3
      pst.str(string("  Servo"))
      pst.dec(displayservo)
      pst.char(" ")
      printThree(FBS.getpos(displayservo))
      pst.str(string("   "))

pub printThree(number)
    if number < 100
      pst.char(" ")
    if number < 10
      pst.char(" ")
    pst.dec(number)
              
                   